Bug 755139 - Review Request: python-nose1.1 - Discovery-based unittest extension for Python
Summary: Review Request: python-nose1.1 - Discovery-based unittest extension for Python
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Steve Traylen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 755065
TreeView+ depends on / blocked
 
Reported: 2011-11-19 00:42 UTC by Toshio Ernie Kuratomi
Modified: 2011-11-29 19:03 UTC (History)
4 users (show)

Fixed In Version: python-nose1.1-1.1.2-4.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-11-29 19:03:11 UTC
steve.traylen: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Toshio Ernie Kuratomi 2011-11-19 00:42:21 UTC
Spec URL: http://toshio.fedorapeople.org/packages/python-nose1.1.spec
SRPM URL: http://toshio.fedorapeople.org/packages/python-nose1.1-1.1.2-2.el6.src.rpm
Description:
nose extends the test loading and running features of unittest, making
it easier to write, find and run tests.

By default, nose will run tests in files or directories under the
current working directory whose names include "test" or "Test" at a
word boundary (like "test_this" or "functional_test" or "TestClass"
but not "libtest"). Test output is similar to that of unittest, but
also includes captured stdout output from failing tests, for easy
print-style debugging.

These features, and many more, are customizable through the use of
plugins. Plugins included with nose provide support for doctest, code
coverage and profiling, flexible attribute-based test selection,
output capture and more.

This package contains a newer version of nose than was originally included for
use by packages that need the features and API made available since the
original package release.

Comment 1 Toshio Ernie Kuratomi 2011-11-19 00:45:03 UTC
This package is intended for EPEL6 (and possibly EPEL5 but I have no need of it there at the moment and the version of python-coverage on EPEL5 would need to be upgraded as well).

Comment 2 Steve Traylen 2011-11-19 15:01:57 UTC
 +:ok, =:needs attention, -:needs fixing

MUST Items:
[=] MUST: rpmlint must be run on every package.
$ rpmlint ./python-nose1.1.spec 
./python-nose1.1.spec: W: invalid-url Source0: nose-1.1.2.tar.gz
See below for source URL.
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

python-nose1.1.src: W: spelling-error Summary(en_US) unittest -> unit test, unit-test, unattested
python-nose1.1.src: W: spelling-error %description -l en_US unittest -> unit test, unit-test, unattested
python-nose1.1.src: W: spelling-error %description -l en_US libtest -> lib test, lib-test, liberate
python-nose1.1.src: W: spelling-error %description -l en_US stdout -> stout, std out, std-out
python-nose1.1.src: W: spelling-error %description -l en_US customizable -> customization, customize, customarily

okay, all in common usage but I don't like customizable very much being British.

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
LGPLv2+ and Public Domain, 
[+] MUST: The License field in the package spec file must match the actual license.
okay the man page is public domain.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
lgpl.txt
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[=] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
It should move to a proper URL.
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
Builds in mock.
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
Builds in mock.
[+] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro.
No locales.
[+] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
No shared links.
[+] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
Not relocatable.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[=] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
$RPM_OPT_FLAGS and %{buildroot} both in use.
[+] MUST: The package must contain code, or permissible content. This is described in detail in the code vs. content section of Packaging Guidelines.
[+] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[+] MUST: Static libraries must be in a -static package.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[+] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[+] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: All filenames in rpm packages must be valid UTF-8.


Summary:
1) I would move to the real source url since the tar works perfectly well on RHEL6.

2) The docs sub-package does not contain the license file and does not require 
   the main package.  I would add a dep on the main package to the doc package.

3) %{buildroot} and $RPM_OPT_FLAGS are in use:
   http://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

   Actually RPM_OPT_FLAGS should not even be there , this is a noarch
   package.

4) A README.Fedora file should be added since this package obviusly falls into
   this category.
   http://fedoraproject.org/wiki/Packaging:Python_Eggs#Multiple_Versions

Quick check that it imports, - yes.

# python
Python 2.6.6 (r266:84292, Jul 20 2011, 10:22:43) 
[GCC 4.4.5 20110214 (Red Hat 4.4.5-6)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> import sys
>>> sys.path.insert(0,'/usr/lib/python2.6/site-packages/nose-1.1.2-py2.6.egg')
>>> import nose

Comment 3 Toshio Ernie Kuratomi 2011-11-19 19:01:02 UTC
(In reply to comment #2)
> Summary:
> 1) I would move to the real source url since the tar works perfectly well on
> RHEL6.
> 
I'm considering whether to build this for EPEL5 as well.  The only thing currently blocking that is an older version of python-coverage which I could either disable the unittests and nose module for it (since it's an extension) or build a forwards compat package for that.  So I'd rather leave the retarred file with the comment explaining the situation and how to create the tarball used.

>  I would add a dep on the main package to the doc package.
>
Done.
 
> Actually RPM_OPT_FLAGS should not even be there

Done.

> 4) A README.Fedora file should be added

Done.

New Package:
SRPM: http://toshio.fedorapeople.org/packages/python-nose1.1-1.1.2-3.fc14.src.rpm
SPEC: http://toshio.fedorapeople.org/packages/python-nose1.1.spec
Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3526236

Comment 4 Toshio Ernie Kuratomi 2011-11-19 19:06:26 UTC
Wrong Koji build URL.  Here's the correct build:

http://koji.fedoraproject.org/koji/taskinfo?taskID=3526259

Comment 5 Steve Traylen 2011-11-19 20:23:03 UTC
Looks good.

change

Requires:       python-nose1.1

to

Requires:       python-nose1.1 = %{version}-%{release}

before import.

APPROVED

I'm assuming that a new package is needed for sqlalchemy0.7, will wait
for one to appear.

Steve.

Comment 6 Toshio Ernie Kuratomi 2011-11-20 06:11:20 UTC
Thanks!

New Package SCM Request
=======================
Package Name: python-nose1.1
Short Description: Discovery-based unittest extension for Python
Owners: toshio lmacken
Branches: el6 el5
InitialCC:

Comment 7 Pádraig Brady 2011-11-21 09:10:15 UTC
Will this spec create python3-nose rather than python3-nose1.1 ?

Comment 8 Pádraig Brady 2011-11-21 09:24:02 UTC
Also for my own reference, I think it would be good if rebasing python-nose in RHEL, that both that and this package Provide: python-nose1
(Note that python-nose-1.0 is enough to build sqlalchemy at least)

That would allow dependent packages to require just python-nose1
and not need to install the actual python-nose1.1 compat package too.
The rebased package would also need to Conflicts: python-nose1.1
as the eggs would overlap.

Comment 9 Steve Traylen 2011-11-21 10:46:27 UTC
(In reply to comment #7)
> Will this spec create python3-nose rather than python3-nose1.1 ?

Indeed I missed this , I ignored the python3 case or rather suggested it should be there 
but given it is there then python3-nose1.1 is very correct and necessary.


Steve

Comment 10 Toshio Ernie Kuratomi 2011-11-21 17:27:59 UTC
(In reply to comment #7)
> Will this spec create python3-nose rather than python3-nose1.1 ?

I haven't tested (no python3 package yet on RHEL6) but the spec should do the right thing or error out:

# In %install
rm %{buildroot}%{_bindir}/nosetests
[..]
mv %{buildroot}%{_bindir}/nosetests-%{python3_version} %{buildroot}%{_bindir}/nosetests%{maj_ver}-%{python3_version}

# In %files
%{_bindir}/nosetests%{maj_ver}-%{python3_version}

Note, the reason that this isn't installed as python3-nosetests%{maj_ver} is that upstream chose to install the python3 script as nosetests-%{python3_version}.  So to maintain consistency with any documentation that upstream generates around this, I stuck with a name that is easy to find via tab completion/etc.

(In reply to comment #8)
> Also for my own reference, I think it would be good if rebasing python-nose in
> RHEL, that both that and this package Provide: python-nose1
> (Note that python-nose-1.0 is enough to build sqlalchemy at least)
> 
I'm loath to do that as python-nose-1.1 has incompatible API changes with python-nose-1.0.  So some things can use either package but other things would break.

> That would allow dependent packages to require just python-nose1
> and not need to install the actual python-nose1.1 compat package too.
> The rebased package would also need to Conflicts: python-nose1.1
> as the eggs would overlap.

The problem with trying to specify what the RHEL package should do is that we have no control over it.  If RHEL were to rebase its nose packages, the right thing would be for it to rebase to 1.1 (as rebasing to 1.0 would also break API compat, they might as well take on the most recent version).  If they do that, they should add an Obsoletes and Provides with python-nose1.1 and we should remove the python-nose1.1 package from EPEL at that time.

Note that the python-nose package will probably not need a Conflicts in any case -- since nose uses distutils rather than setuptools, its egg-info will use a different name and format than this package:

compat package installed via easy_install:
  /usr/lib/python2.6/site-packages/nose-1.1.2-py2.6.egg
standard nose installed with distutils:
  /usr/lib/python2.6/site-packages/nose-1.1.2-py2.6.egg-info

Comment 11 Gwyn Ciesla 2011-11-27 22:06:54 UTC
Git done (by process-git-requests).

Steve, please take ownership of review BZs, thanks!

Comment 12 Fedora Update System 2011-11-28 12:07:51 UTC
python-nose1.1-1.1.2-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-nose1.1-1.1.2-4.el6

Comment 13 Fedora Update System 2011-11-28 19:29:42 UTC
python-nose1.1-1.1.2-4.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 14 Fedora Update System 2011-11-29 19:03:11 UTC
python-nose1.1-1.1.2-4.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.